package dev.ninjdai.werewolf.uhc.roles;

import dev.ninjdai.werewolf.uhc.effects.Effect;
import net.minestom.server.item.ItemStack;

import java.util.Arrays;
import java.util.List;

public class Role {
    public Role(List<ItemStack> roleItems, List<Effect> roleEffects) {
        this.roleItems = roleItems;
        this.roleEffects = roleEffects;
    }

    Role(Builder builder) {
        this.roleItems = builder.roleItems;
        this.roleEffects = builder.roleEffects;
    }

    List<ItemStack> roleItems;
    List<Effect> roleEffects;

    public static class Builder {
        private List<ItemStack> roleItems = List.of();
        private List<Effect> roleEffects = List.of();

        public Builder setRoleItems(List<ItemStack> roleItems) {
            this.roleItems = roleItems;
            return this;
        }

        public Builder addRoleItems(ItemStack ... roleItems) {
            this.roleItems.addAll(Arrays.asList(roleItems));
            return this;
        }

        public Builder setRoleEffects(List<Effect> roleEffects) {
            this.roleEffects = roleEffects;
            return this;
        }

        public Builder addRoleEffects(Effect... roleEffects) {
            this.roleEffects.addAll(Arrays.asList(roleEffects));
            return this;
        }

        public Role build() {
            return new Role(this);
        }
    }
}
